<html>
<head>
<title>OGRE: OgreRay.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreRay.h</h1><a href="OgreRay_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Ray_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Ray_H_</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Precompiler options</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgrePlaneBoundedVolume_8h.html">OgrePlaneBoundedVolume.h</a>"</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00041"></a><a class="code" href="classOgre_1_1Ray.html">00041</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, ie a line with an origin and direction.">Ray</a>
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043     <span class="keyword">protected</span>:
<a name="l00044"></a><a class="code" href="classOgre_1_1Ray.html#149235772702fe06ef8dc15a37ee6e05">00044</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mOrigin;
<a name="l00045"></a><a class="code" href="classOgre_1_1Ray.html#9b3de04f46afb4fb72353685a51d6ada">00045</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> mDirection;
<a name="l00046"></a>00046     <span class="keyword">public</span>:
<a name="l00047"></a><a class="code" href="classOgre_1_1Ray.html#e06168a69567ec6ede584cfa8ced9979">00047</a>         <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, ie a line with an origin and direction.">Ray</a>():mOrigin(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::ZERO), mDirection(<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>::UNIT_Z) {}
<a name="l00048"></a><a class="code" href="classOgre_1_1Ray.html#7da08421bf78a27884c5a381cda60dc2">00048</a>         <a class="code" href="classOgre_1_1Ray.html" title="Representation of a ray in space, ie a line with an origin and direction.">Ray</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; origin, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; direction)
<a name="l00049"></a>00049             :mOrigin(origin), mDirection(direction) {}
<a name="l00050"></a>00050 
<a name="l00052"></a><a class="code" href="classOgre_1_1Ray.html#730a34d1255a51df2bb072c823acec67">00052</a>         <span class="keywordtype">void</span> setOrigin(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; origin) {mOrigin = origin;} 
<a name="l00054"></a><a class="code" href="classOgre_1_1Ray.html#e4e2561675e05fee24c867e3c9137c21">00054</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getOrigin(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{<span class="keywordflow">return</span> mOrigin;} 
<a name="l00055"></a>00055 
<a name="l00057"></a><a class="code" href="classOgre_1_1Ray.html#c3082e7ed2efd58bb202043101d4abb2">00057</a>         <span class="keywordtype">void</span> setDirection(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; dir) {mDirection = dir;} 
<a name="l00059"></a><a class="code" href="classOgre_1_1Ray.html#2d16c049e57a9908e7200bcfc47fd7dc">00059</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getDirection(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{<span class="keywordflow">return</span> mDirection;} 
<a name="l00060"></a>00060 
<a name="l00062"></a><a class="code" href="classOgre_1_1Ray.html#724bffb5c8bd6e79b35a48292075e6db">00062</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> getPoint(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t)<span class="keyword"> const </span>{ 
<a name="l00063"></a>00063             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>(mOrigin + (mDirection * t));
<a name="l00064"></a>00064         }
<a name="l00065"></a>00065         
<a name="l00067"></a><a class="code" href="classOgre_1_1Ray.html#33d296a44a9a3813108e9abcaed7418d">00067</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="namespaceOgre.html#8c1aea4f2e6336301a39efede7ef553b">operator*</a>(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t)<span class="keyword"> const </span>{ 
<a name="l00068"></a>00068             <span class="keywordflow">return</span> getPoint(t);
<a name="l00069"></a>00069         };
<a name="l00070"></a>00070 
<a name="l00077"></a><a class="code" href="classOgre_1_1Ray.html#3471b68f559bd39e79e18f752b720f0f">00077</a>         std::pair&lt;bool, Real&gt; intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; p)<span class="keyword"> const</span>
<a name="l00078"></a>00078 <span class="keyword">        </span>{
<a name="l00079"></a>00079             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, p);
<a name="l00080"></a>00080         }
<a name="l00087"></a><a class="code" href="classOgre_1_1Ray.html#dce8c31c39804bc7385e650cbe18fec3">00087</a>         std::pair&lt;bool, Real&gt; intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PlaneBoundedVolume.html" title="Represents a convex volume bounded by planes.">PlaneBoundedVolume</a>&amp; p)<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword">        </span>{
<a name="l00089"></a>00089             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, p.<a class="code" href="classOgre_1_1PlaneBoundedVolume.html#20b9a9b8d76a970c5f6cbac4cb438054" title="Publicly accessible plane list, you can modify this direct.">planes</a>, p.<a class="code" href="classOgre_1_1PlaneBoundedVolume.html#4d323aac2569fdb268dd6dda2801896e">outside</a> == <a class="code" href="classOgre_1_1Plane.html#a5d44b14d6f032f3e0a26e83589180bcc5f2b56ac439b77aad6dfc4031891be5">Plane::POSITIVE_SIDE</a>);
<a name="l00090"></a>00090         }
<a name="l00097"></a><a class="code" href="classOgre_1_1Ray.html#200a9f8c30f388bd4b4c195f10d09720">00097</a>         std::pair&lt;bool, Real&gt; intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Sphere.html" title="A sphere primitive, mostly used for bounds checking.">Sphere</a>&amp; s)<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword">        </span>{
<a name="l00099"></a>00099             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, s);
<a name="l00100"></a>00100         }
<a name="l00107"></a><a class="code" href="classOgre_1_1Ray.html#c14cf4c98cc75e531a1fd43fab4eeeff">00107</a>         std::pair&lt;bool, Real&gt; intersects(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box)<span class="keyword"> const</span>
<a name="l00108"></a>00108 <span class="keyword">        </span>{
<a name="l00109"></a>00109             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#11664bfebecca73dbb42c0959d3d9ff7" title="Ray / plane intersection, returns boolean result and distance.">Math::intersects</a>(*<span class="keyword">this</span>, box);
<a name="l00110"></a>00110         }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     };
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
